path = require 'path'
{ readFile } = require 'fs'
{ EventEmitter } = require 'events'
{ Template } = require '../dynamictemplate'
util = require 'util'
util.orginspect = util.inspect
util.inspect = require('eyes').inspector(stream: null)
module.exports =

    simple: (æ) ->
        xml = new Template ->
            @$tag('test')
        xml.on 'end', æ.done
        xml.on 'data', (tag) -> æ.equal "<test/>", tag


    html5: (æ) ->
        content = ["a", "b", "c"]
        xml = new Template schema:5, ->
            @$html ->
                @body ->
                    file = path.join(__dirname,"..","..","..","filename")
                    readFile file, (err, filedata) =>
                        @$div class:'test', (filedata or err)
                        @$ul ->
                            content.forEach (data) =>
                                li = @$li({'data-content':data}, data)
#                                 ee.on "content::#{data}", (new_data) ->
#                                     li.attr("data-content", new_data)
                        @end()

#     ee.emit("content::a", "blabla")

        xml.on 'end', æ.done
        xml.on 'data', (tag) -> æ.equal results.shift(), tag
        results = [
            '<!DOCTYPE html>'
            '<html>'
            '<body>'
            '<div class="test">'
            'hello world\n'
            '</div>'
            '<ul>'
            '<li data-content="a">'
            'a'
            '</li>'
            '<li data-content="b">'
            'b'
            '</li>'
            '<li data-content="c">'
            'c'
            '</li>'
            '</ul>'
            '</body>'
            '</html>'
        ]

    'layout': (æ) ->

        layout = ({title}, callback) ->
            new Template schema:'html5', ->
                @$html ->
                    @$head ->
                        @$title title
                    @$body ->
                        @div class:'body', ->
                            callback?.call(this)

        template = (data) ->
            layout data, ->
                @$p data.content
                @end()


        xml = template data =
            title:'test'
            content:'..'

        xml.on 'end', æ.done
        xml.on 'data', (tag) -> æ.equal results.shift(), tag
        results = [
            '<!DOCTYPE html>'
            '<html>'
            '<head>'
            '<title>'
            data.title
            '</title>'
            '</head>'
            '<body>'
            '<div class="body">'
            '<p>'
            data.content
            '</p>'
            '</div>'
            '</body>'
            '</html>'
        ]
#         setTimeout (->
#             console.log xml
#         ), 1000

# xmlee.on 'add', (el) ->
#     el._jquery = $(el.toString()).append(el.up(end:no)._jquery)


# T#ODO end in up is not good when we just want to get the parent

# T#ODO pipe stream into tag
# T#ODO emit tag data when closing tag, so we can manipulate it after creation and still get the right xml from it
# T#ODO give a tag a children scope after tha tag was created
# TODO tag order?

# TODO add clone method to tag so tags can be cloned (param: deep for deep copy)


# TODO read from dom function
# TODO doctype

# dom list operations:
#     append
#     insertbefore
#     remove
#     replace

# NodeList

# test = xml.tag 'test', a:3
#
#
#
# data.on 'change', (a) -> test.attr {a}
# data.on 'item', (item) ->
#     test.tag 'item', item
#
#
# tag.end()
